unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Process;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnRun: TButton;
    edtFilePath: TEdit;
    Label1: TLabel;
    mmoScript: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtBatchPath: TEdit;
    chxNoConsole: TCheckBox;
    chkWaitOnExit: TCheckBox;
    procedure btnRunClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnRunClick(Sender: TObject);
var
  StrList: TStrings;
  P: TProcess;
begin
  StrList := TStringList.Create;
  P := TProcess.Create(nil);
  try
    // file
    StrList.Text := 'foo';
    StrList.SaveToFile(edtFilePath.Text);
    ShowMessage(edtFilePath.Text + ' created.');

    // batch
    mmoScript.Lines.SaveToFile(edtBatchPath.Text);
    ShowMessage(edtBatchPath.Text + ' created.');

    if chkWaitOnExit.Checked then
      P.Options := P.Options + [poWaitOnExit]
    else
      P.Options := P.Options - [poWaitOnExit];

    if chxNoConsole.Checked then
      P.Options := P.Options + [poNoConsole]
    else
      P.Options := P.Options - [poNoConsole];

    P.Executable := edtBatchPath.Text;
    P.Parameters.Add(edtFilePath.Text);

    ShowMessage('Run ' + P.Executable + ' ' + P.Parameters.Text + #13 + mmoScript.Text);

    P.Execute;

    if FileExistsUTF8(edtFilePath.Text) then
      ShowMessage('Did not work')
    else
      ShowMessage('Ok');
  finally
    P.Free;
    StrList.Free;
  end;
end;

end.

